/**
 * PAUL HUSSMAN
 * 260224172
 * COMP 409 ASSIGNMENT 4
 * FALL 2010
 */

import java.util.ArrayList;
import java.awt.*;

/** A Circuit which simulates a simple for-loop around a function F. */
public class CircuitLoop extends Circuit {

    /** How many times the loop iterates. */
    private static final int N = 3;

    /** Set the size in the constructor. */
    public CircuitLoop() {
        GUIW = 41;
        GUIH = 30;
    }

    /** Basically a for loop, 
     *     for (int i=0;i<N;i++) {
     *         x = f(x);
     *     }
     *  For some input/output variable x.
     **/
    public void build() {
        int i;
        // allocate channels
        ArrayList<Channel<Integer>> ic = new ArrayList<Channel<Integer>>();
        for (i=0;i<25;i++) 
            ic.add(new Channel<Integer>());
        ArrayList<Channel<Boolean>> bc = new ArrayList<Channel<Boolean>>();
        for (i=0;i<7;i++) 
            bc.add(new Channel<Boolean>());

        // connect channels to make longer paths
        ic.get(3).linkTo(ic.get(4));
        ic.get(4).linkTo(ic.get(5));
        ic.get(6).linkTo(ic.get(7));
        ic.get(7).linkTo(ic.get(8));

        ic.get(17).linkTo(ic.get(18));

        ic.get(11).linkTo(ic.get(12));
        ic.get(12).linkTo(ic.get(13));
        ic.get(14).linkTo(ic.get(15));
        ic.get(15).linkTo(ic.get(16));

        ic.get(20).linkTo(ic.get(21));
        ic.get(21).linkTo(ic.get(22));
        ic.get(22).linkTo(ic.get(23));
        ic.get(23).linkTo(ic.get(24));

        // add any branching
        FunctionFork<Integer> fork1 = new FunctionFork<Integer>(ic.get(9),ic.get(10),ic.get(17));
        FunctionFork<Boolean> fork2 = new FunctionFork<Boolean>(bc.get(0),bc.get(1),bc.get(2));
        FunctionFork<Boolean> fork3 = new FunctionFork<Boolean>(bc.get(2),bc.get(3),bc.get(4));
        FunctionFork<Boolean> fork4 = new FunctionFork<Boolean>(bc.get(4),bc.get(5),bc.get(6));
        
        // now create functions
        FunctionMerge<Integer> merge1 = new FunctionMerge<Integer>(ic.get(16),ic.get(24),ic.get(9),bc.get(5));
        FunctionMerge<Integer> merge2 = new FunctionMerge<Integer>(ic.get(8),ic.get(0),ic.get(1),bc.get(6),true);
        merge1.label = "Merge-1";
        merge2.label = "Merge-2";

        FunctionSwitch<Integer> switch1 = new FunctionSwitch<Integer>(ic.get(10),ic.get(11),ic.get(19),bc.get(1));
        FunctionSwitch<Integer> switch2 = new FunctionSwitch<Integer>(ic.get(1),ic.get(3),ic.get(2),bc.get(3),true);
        switch1.label = "Switch-1";
        switch2.label = "Switch-2";

        FunctionCompare compare = new FunctionCompare(ic.get(18),bc.get(0),N);

        FunctionInc inc = new FunctionInc(ic.get(13),ic.get(14));

        FunctionF funcf = new FunctionF(ic.get(5),ic.get(6));

        FunctionEmit0 emit0 = new FunctionEmit0(ic.get(19),ic.get(20));

        FunctionOutput output = new FunctionOutput(ic.get(2));
        FunctionInput input = new FunctionInput(ic.get(0));

        // assign coordinates to components

        merge1.x = 7*SCALE; merge1.y = 6*SCALE; merge1.w = 8*SCALE; merge1.h = 2*SCALE;
        merge2.x = 27*SCALE; merge2.y = 6*SCALE; merge2.w = 8*SCALE; merge2.h = 2*SCALE;

        switch1.x = 7*SCALE; switch1.y = 16*SCALE; switch1.w = 8*SCALE; switch1.h = 2*SCALE;
        switch2.x = 27*SCALE; switch2.y = 16*SCALE; switch2.w = 8*SCALE; switch2.h = 2*SCALE;

        compare.x = 17*SCALE; compare.y = 12*SCALE; compare.w = 4*SCALE; compare.h = 2*SCALE;

        inc.x = 3*SCALE; inc.y = 11*SCALE; inc.w = 4*SCALE; inc.h = 2*SCALE;

        funcf.x = 35*SCALE; funcf.y = 11*SCALE; funcf.w = 4*SCALE; funcf.h = 2*SCALE;

        emit0.x = 11*SCALE; emit0.y = 21*SCALE; emit0.w = 4*SCALE; emit0.h = 2*SCALE;

        output.x = 25*SCALE; output.y = 21*SCALE; output.w = 8*SCALE; output.h = 2*SCALE;

        input.x = 25*SCALE; input.y = 1*SCALE; input.w = 8*SCALE; input.h = 2*SCALE;

        fork1.x = 11*SCALE; fork1.y = 10*SCALE;
        fork2.x = 19*SCALE; fork2.y = 17*SCALE;
        fork3.x = 24*SCALE; fork3.y = 17*SCALE;
        fork4.x = 24*SCALE; fork4.y = 7*SCALE;

        merge1.setPoints(); merge2.setPoints();
        switch1.setPoints(); switch2.setPoints();
        compare.setPoints(); 
        inc.setPoints();
        funcf.setPoints();
        emit0.setPoints();
        output.setPoints();
        input.setPoints();
        fork1.setPoints(); fork2.setPoints(); fork3.setPoints(); fork4.setPoints();

        // assign coordinates to chains of channels.  Just need to
        // assign hanging destinations.  All channels must be axis-aligned.
        ic.get(3).dx = 33*SCALE; ic.get(3).dy = 20*SCALE;
        ic.get(4).dx = 37*SCALE; ic.get(4).dy = 20*SCALE;
        ic.get(6).dx = 37*SCALE; ic.get(6).dy = 4*SCALE;
        ic.get(7).dx = 33*SCALE; ic.get(7).dy = 4*SCALE;

        ic.get(17).dx = 19*SCALE; ic.get(17).dy = 10*SCALE;

        ic.get(11).dx = 9*SCALE; ic.get(11).dy = 20*SCALE;
        ic.get(12).dx = 5*SCALE; ic.get(12).dy = 20*SCALE;
        ic.get(14).dx = 5*SCALE; ic.get(14).dy = 4*SCALE;
        ic.get(15).dx = 9*SCALE; ic.get(15).dy = 4*SCALE;

        ic.get(20).dx = 13*SCALE; ic.get(20).dy = 25*SCALE;
        ic.get(21).dx = 2*SCALE; ic.get(21).dy = 25*SCALE;
        ic.get(22).dx = 2*SCALE; ic.get(22).dy = 2*SCALE;
        ic.get(23).dx = 13*SCALE; ic.get(23).dy = 2*SCALE;

        // set remaining start points for channels and
        // add all components to the funcs list
        for (Channel<Integer> c : ic) {
            c.setPoints();
            funcs.add(c);
        }
        for (Channel<Boolean> b : bc) {
            funcs.add(b);
        }
        funcs.add(fork1);
        funcs.add(fork2);
        funcs.add(fork3);
        funcs.add(fork4);
        funcs.add(merge1);
        funcs.add(merge2);
        funcs.add(switch1);
        funcs.add(switch2);
        funcs.add(compare);
        funcs.add(inc);
        funcs.add(funcf);
        funcs.add(emit0);
        funcs.add(input);
        funcs.add(output);

        // create initial tokens
        ic.get(24).send(new Integer(0));
        bc.get(5).send(new Boolean(false));
        bc.get(6).send(new Boolean(false));
    }
}
