import java.awt.*;

/** A function which discards its first input and then
 * copies input to output. */
public class FunctionCDR<T> extends Function {
    /** Channels. */
    private Channel<T> in;
    private Channel<T> out;

    private boolean first = true;

    public FunctionCDR(Channel<T> in,Channel<T> out) {
        this.in = in;
        this.out = out;
        label = "CDR";
    }

    public void setPoints() {
        in.dx = x+w/2;
        in.dy = y;
        out.x = x+w;
        out.y = y+h/2;
    }

    protected void canFire() {
        in.mustReceive();
        if (!first)
        out.mustSend();
    }

    protected void fire() {
        T i = in.receive();
        if (Circuit.debug)
            System.out.println("Emit0: "+i+ ((first) ? " discarded" : " copied"));
        if (first) 
            first = false;
        else
            out.send(i);
    }
}
