import java.awt.*;

/** A comparing function.  This one just does a simple
 * comparison again a constant. */
public class FunctionCompare extends Function {
    /** Channels. */
    private Channel<Integer> in;
    private Channel<Boolean> out;

    /** Constant comparison value. */
    private int n = 3;

    public FunctionCompare(Channel<Integer> in,Channel<Boolean> out,int n) {
        this.in = in;
        this.out = out;
        this.n = n;
        label = "< "+n;
    }

    public void setPoints() {
        in.dx = x+w/2;
        in.dy = y;
        out.x = x+w/2;
        out.y = y+h;
    }

    protected void canFire() {
        in.mustReceive();
        out.mustSend();
    }

    protected void fire() {
        Integer i = in.receive();
        if (Circuit.debug)
            System.out.println("Comparing: "+i);
        if (i.intValue()<n)
            out.send(new Boolean(true));
        else
            out.send(new Boolean(false));
    }
}
