import java.awt.*;

/** A function which emits a 0 every time it receives
 * any integer input. */
public class FunctionEmit0 extends Function {
    /** Channels. */
    private Channel<Integer> in;
    private Channel<Integer> out;

    public FunctionEmit0(Channel<Integer> in,Channel<Integer> out) {
        this.in = in;
        this.out = out;
        label = "Emit 0";
    }

    public void setPoints() {
        in.dx = x+w/2;
        in.dy = y;
        out.x = x+w/2;
        out.y = y+h;
    }

    protected void canFire() {
        in.mustReceive();
        out.mustSend();
    }

    protected void fire() {
        Integer i = in.receive();
        i = new Integer(0);
        if (Circuit.debug)
            System.out.println("Emit0: 0");
        out.send(i);
    }
}
