import java.awt.*;

/** A fork point is actually a function. */
public class FunctionFork<T> extends Function {
    /** Channels. */
    private Channel<T> in,out1,out2;

    public FunctionFork(Channel<T> in,Channel<T> out1,Channel<T> out2) {
        this.in = in;
        this.out1 = out1;
        this.out2 = out2;
    }

    public void setPoints() {
        in.dx = x;
        in.dy = y;
        out1.x = x;
        out1.y = y;
        out2.x = x;
        out2.y = y;
    }

    /** Drawing is easy; a fork point isn't drawn. */
    public void draw(Graphics g) {
    }

    protected void canFire() {
        in.mustReceive();
        out1.mustSend();
        out2.mustSend();
    }

    protected void fire() {
        T i = in.receive();
        if (Circuit.debug)
            System.out.println("Forking: "+i);
        out1.send(i);
        out2.send(i);
    }
}
