import java.awt.*;

/** A simple incrementer. */
public class FunctionInc extends Function {
    /** Channels. */
    private Channel<Integer> in,out;

    /** For drawing upside down. */
    private boolean refl;
    
    public FunctionInc(Channel<Integer> in,Channel<Integer> out) {
        this.in = in;
        this.out = out;
        label = "++";
    }
    
    public FunctionInc(Channel<Integer> in,Channel<Integer> out,boolean refl) {
        this.in = in;
        this.out = out;
        this.refl = refl;
        label = "++";
    }
    
    public void setPoints() {
        in.dx = x+w/2;
        if (refl)
            in.dy = y;
        else
            in.dy = y+h;
        out.x = x+w/2;
        if (refl)
            out.y = y+h;
        else
            out.y = y;
    }
    
    protected void canFire() {
        in.mustReceive();
        out.mustSend();
    }
    
    protected void fire() {
        Integer i = in.receive();
        i = new Integer(i.intValue()+1);
        if (Circuit.debug)
            System.out.println("Incrementing: "+(i.intValue()-1)+" to "+i.intValue());
        out.send(i);
    }
}
