import java.util.Scanner;
import java.awt.*;

/** An input stream.  Uses System.in so there can only
 * be one of these. */
public class FunctionInput extends Function {
    /** Channel to send input to. */
    private Channel<Integer> out;
    
    /** A Scanner for reading input. */
    private Scanner s = new Scanner(System.in);

    public FunctionInput(Channel<Integer> out) {
        this.out = out;
        label = "Input";
    }

    public void setPoints() {
        out.x = x+w/2;
        out.y = y+h;
    }

    protected void canFire() {
        out.mustSend();
        label = "Input: ?";
    }

    protected void fire() {
        System.out.print("Input: ");
        Integer i = new Integer(s.nextInt());
        s.nextLine();
        // change label so input value is displayed
        label = "Input: "+i;
        out.send(i);
    }
}
