import java.awt.*;

/** An output component.  Receives data and prints
 * it out to the console, and displays it too
 * (until the next output overwrites it). */
public class FunctionOutput extends Function {
    /** Channel providing data. */
    private Channel<Integer> in;

    /** Input on the left instead of top. */
    private boolean sideways;

    public FunctionOutput(Channel<Integer> in) {
        this.in = in;
        label = "Output: ";
    }

    public FunctionOutput(Channel<Integer> in,boolean sideways) {
        this(in);
        this.sideways = sideways;
    }

    public void setPoints() {
        if (sideways) {
            in.dx = x;
            in.dy = y+h/2;
        } else {
            in.dx = x+w/2;
            in.dy = y;
        }
    }

    protected void canFire() {
        in.mustReceive();
    }

    protected void fire() {
        Integer i = in.receive();
        // change label to show data
        label = "Output: "+i;
        System.out.println("Output: "+i);
    }
}
